package org.ow2.petals.se.sca;

import javax.jbi.component.ComponentContext;
import javax.jbi.messaging.DeliveryChannel;
import java.util.HashMap;
import java.util.Map;
import javax.xml.namespace.QName;
import org.ow2.petals.databinding.jaxb.service.Service;
import java.util.Set;

/** 
 * 
 * This class gets the ComponentContext and the DeliveryChannel JBI 
 * objects. These objects are used by the stub generated by the Binding Factory
 * to call a JBI endpoint.
 * 
 * @author Mohammed EL JAI  - eBM Websourcing
 */
public class PetalsGateway {
    /** 
     *
     */
    private static ComponentContext componentContext;
    
    /** 
     *
     */
    private static DeliveryChannel deliveryChannel;
    
    /** 
     *
     */
    private static Map<javax.xml.namespace.QName, org.ow2.petals.databinding.jaxb.service.Service>  suReferencesPool;
    
    /** 
     * The constructor to initialize the attributes
     */
    public PetalsGateway(ComponentContext componentContext ,DeliveryChannel deliveryChannel) {
        PetalsGateway.suReferencesPool = new HashMap<javax.xml.namespace.QName, org.ow2.petals.databinding.jaxb.service.Service> ();
        PetalsGateway.componentContext = componentContext;
        PetalsGateway.deliveryChannel = deliveryChannel;
    }
    
    /** 
     * Get the Component context object
     */
    public static ComponentContext getComponentContext() {
        return PetalsGateway.componentContext;
    }
    
    /** 
     * Get the Delivery Channel object
     */
    public static DeliveryChannel getDeliveryChannel() {
        return PetalsGateway.deliveryChannel;
    }
    
    /** 
     * Get the Service associated with the reference composite whose name is given in parameter.
     */
    public static Service getReferenceByName(QName referenceName) {
        for (QName reference : PetalsGateway.suReferencesPool.keySet()) {
            if (reference.getLocalPart().equals(referenceName.getLocalPart())) {
                return PetalsGateway.suReferencesPool.get(reference);
            } 
        }
        return null;
    }
    
    /** 
     * Get the references Pool
     */
    public static Map<javax.xml.namespace.QName, org.ow2.petals.databinding.jaxb.service.Service>  getSuReferencesPool() {
        return PetalsGateway.suReferencesPool;
    }
    
}

