package org.ow2.petals.se.sca;

import org.eclipse.stp.sca.Composite;
import org.eclipse.stp.sca.DocumentRoot;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.stp.sca.domainmodel.frascati.FrascatiPackage;
import java.io.IOException;
import java.util.Map;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.stp.sca.ScaPackage;
import org.eclipse.stp.sca.util.ScaResourceFactoryImpl;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

public class Util {
    /** 
     *
     */
    private static final String SCA_FILENAME_EXT = ".composite";
    
    /** 
     * 
     * @param compositeFileName
     * @return
     * @throws IOException
     */
    public static Composite parse(String compositeFileName) throws IOException {
        URI uri = Util.getCompositeResource(compositeFileName);
        ResourceSet resourceSet = new ResourceSetImpl();
        resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("*" ,new ScaResourceFactoryImpl());
        resourceSet.getPackageRegistry().put(ScaPackage.eNS_URI ,ScaPackage.eINSTANCE);
        resourceSet.getPackageRegistry().put(FrascatiPackage.eNS_URI ,FrascatiPackage.eINSTANCE);
        org.eclipse.emf.common.util.URI resourceUri = org.eclipse.emf.common.util.URI.createURI(uri.toString());
        Resource resource = resourceSet.getResource(resourceUri ,true);
        EList<org.eclipse.emf.ecore.EObject>  list = resource.getContents();
        Composite composite = ((DocumentRoot)(list.get(0))).getComposite();
        list = null;
        resource = null;
        return composite;
    }
    
    /** 
     * Get the URI of the SCA composite
     * @param compositeFile
     * @return
     */
    public static URI getCompositeResource(String compositeFile) {
        try {
            URI compositeUri = null;
            if (!(compositeFile.endsWith(SCA_FILENAME_EXT)))
                compositeFile = compositeFile + (SCA_FILENAME_EXT);
            
            URL compositeUrl = Thread.currentThread().getContextClassLoader().getResource(compositeFile);
            if (compositeUrl != null) {
                return compositeUrl.toURI();
            } else {
                compositeUri = URI.create(compositeFile);
            }
            return compositeUri;
        } catch (URISyntaxException e) {
            throw new Error("Could not retrieve valid URI for this composite resource");
        }
    }
    
}

