package org.ow2.petals.se.sca.binding;

import java.util.ArrayList;
import org.eclipse.stp.sca.BaseReference;
import org.eclipse.stp.sca.BaseService;
import org.eclipse.stp.sca.Binding;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.bf.BindingFactory;
import org.objectweb.fractal.bf.BindingFactoryException;
import org.objectweb.fractal.fraclet.annotations.Component;
import org.eclipse.stp.sca.domainmodel.frascati.FrascatiPackage;
import java.util.HashMap;
import org.eclipse.stp.sca.domainmodel.frascati.JBIBinding;
import org.ow2.petals.se.sca.connectors.jbi.JbiConnectorConstants;
import java.util.List;
import java.util.logging.Logger;
import java.util.Map;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import javax.xml.namespace.QName;
import org.objectweb.fractal.fraclet.annotations.Requires;
import org.ow2.frascati.factory.core.instance.binding.ScaBindingProtocol;

/** 
 * Bind components using the JBI Binding
 * @author Mohammed EL JAI
 */
@Component
public class ScaBindingJBI implements BindingController , ScaBindingProtocol {
    /** 
     * The binding type according to the SCA model 
     */
    public static int BINDING_TYPE = FrascatiPackage.JBI_BINDING;
    
    /** 
     * Logger for this class
     */
    Logger log = Logger.getLogger(ScaBindingJBI.class.getCanonicalName());
    
    public String[] listFc() {
        List<java.lang.String>  __itfs__ = new ArrayList<java.lang.String> ();
        listFc(__itfs__);
        return __itfs__.toArray(new String[__itfs__.size()]);
    }
    
    @Requires(name = "binding-factory")
    BindingFactory bf;
    
    public void bind(BaseReference reference, Binding binding, org.objectweb.fractal.api.Component component) {
        JBIBinding b = ((JBIBinding)(binding));
        QName serviceName = new QName(b.getServiceNamespace() , b.getServiceName());
        QName intefaceName = new QName(b.getInterfaceNamespace() , b.getInterfaceName());
        String endpoint = b.getEndpointName();
        String referenceName = org.ow2.frascati.factory.core.instance.binding.ScaBindingUtil.getReferenceName(reference);
        HashMap<java.lang.String, java.lang.String>  m = new HashMap<java.lang.String, java.lang.String> ();
        m.put(JbiConnectorConstants.SERVICE_NAME ,serviceName.toString());
        m.put(JbiConnectorConstants.INTERFACE_NAME ,intefaceName.toString());
        m.put(JbiConnectorConstants.ENDPOINT ,endpoint);
        m.put(ScaBindingProtocol.PLUGIN_ID ,"jbi");
        try {
            log.fine(((((((((((((("Calling binding factory\n bind : " + (org.objectweb.fractal.util.Fractal.getNameController(component).getFcName())) + " -> ") + referenceName) + "\n with ") + (JbiConnectorConstants.SERVICE_NAME)) + "=") + (serviceName.toString())) + (JbiConnectorConstants.INTERFACE_NAME)) + "=") + (intefaceName.toString())) + (JbiConnectorConstants.ENDPOINT)) + "=") + endpoint));
            bf.bind(component ,referenceName ,m);
        } catch (BindingFactoryException e) {
            e.printStackTrace();
        } catch (NoSuchInterfaceException e) {
            log.severe("Error while getting component name controller");
            e.printStackTrace();
        }
    }
    
    /** 
     * Completes the list of bound interfaces.
     * 
     * @param set incomplete list of interface identifiers.
     */
    protected void listFc(List<java.lang.String>  set) {
        if ((this.bf) != null)
            set.add("binding-factory");
        
    }
    
    public Object lookupFc(String id) throws NoSuchInterfaceException {
        if (id.equals("binding-factory"))
            return this.bf;
        
        throw new NoSuchInterfaceException((("Client interface \'" + id) + "\' is undefined."));
    }
    
    public void bindFc(String id, Object ref) throws NoSuchInterfaceException {
        if (id.equals("binding-factory")) {
            this.bf = ((BindingFactory)(ref));
            return ;
        } 
        throw new NoSuchInterfaceException((("Client interface \'" + id) + "\' is undefined."));
    }
    
    public void unbindFc(String id) throws NoSuchInterfaceException {
        if (id.equals("binding-factory")) {
            this.bf = null;
            return ;
        } 
        throw new NoSuchInterfaceException((("Client interface \'" + id) + "\' is undefined."));
    }
    
    public void export(BaseService service, Binding binding, org.objectweb.fractal.api.Component component) {
    }
    
    public int getBindingID() {
        return ScaBindingJBI.BINDING_TYPE;
    }
    
}

