package org.ow2.petals.se.sca.connectors.jbi;

import org.objectweb.fractal.bf.AbstractBindingFactoryPlugin;
import org.objectweb.fractal.bf.BindHints;
import org.objectweb.fractal.bf.BindingFactoryException;
import org.objectweb.fractal.api.Component;
import java.util.logging.Logger;
import java.util.Map;
import javax.xml.namespace.QName;
import org.objectweb.fractal.bf.SkeletonGenerationException;
import org.objectweb.fractal.bf.proxies.StubComponentFactory;

/** 
 * A WS-Connector can export a Fractal interface to make it available via SOAP.
 * 
 * @author Mohammed EL JAI
 */
public class JbiConnector extends AbstractBindingFactoryPlugin<org.ow2.petals.se.sca.connectors.jbi.JbiExportHints, org.ow2.petals.se.sca.connectors.jbi.JbiBindHints>  {
    Logger log = Logger.getLogger(JbiConnector.class.getCanonicalName());
    
    /** 
     * Default 0-args constructor to please Julia.
     */
    public JbiConnector() {
    }
    
    public void finalizeSkeleton(Component skel, Map<java.lang.String, java.lang.String>  finalizationHints) throws BindingFactoryException {
    }
    
    @Override
    public String toString() {
        return "Jbi/PEtALS Connector Plugin";
    }
    
    /** 
     * @see org.objectweb.fractal.bf.BindingFactoryPlugin#getStubComponentFactory()
     */
    public StubComponentFactory getStubComponentFactory() {
        return new JbiConnectorStubComponentFactoryImpl();
    }
    
    /** 
     * @throws BindingFactoryException
     * @see org.objectweb.fractal.bf.BindingFactoryPlugin#getStubGenerationParameters(java.util.Map)
     */
    public String[] getStubGenerationParameters(Map<java.lang.String, java.lang.String>  hints) throws BindingFactoryException {
        String[] params = new String[3];
        params[0] = hints.get(JbiConnectorConstants.INTERFACE_NAME);
        params[1] = hints.get(JbiConnectorConstants.SERVICE_NAME);
        params[2] = hints.get(JbiConnectorConstants.ENDPOINT);
        return params;
    }
    
    /** 
     * @see org.objectweb.fractal.bf.BindingFactoryPlugin#getPluginIdentifier()
     */
    public String getPluginIdentifier() {
        return "jbi";
    }
    
    public Component createSkel(String arg0, Object arg1, Component arg2, JbiExportHints arg3) throws SkeletonGenerationException {
        return null;
    }
    
    public BindHints getBindHints(Map<java.lang.String, java.lang.String>  initialHints) {
        JbiBindHints jbiBindHints = new JbiBindHints();
        jbiBindHints.setEndpoint(initialHints.get(JbiConnectorConstants.ENDPOINT));
        jbiBindHints.setServiceName(QName.valueOf(initialHints.get(JbiConnectorConstants.SERVICE_NAME)));
        jbiBindHints.setInterfaceName(QName.valueOf(initialHints.get(JbiConnectorConstants.INTERFACE_NAME)));
        return jbiBindHints;
    }
    
    public JbiExportHints getExportHints(Map<java.lang.String, java.lang.String>  initialHints) {
        JbiExportHints JbiExportHints = new JbiExportHints();
        log.fine(("Initial hints:" + initialHints));
        return JbiExportHints;
    }
    
}

